"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tree = void 0;
var react_1 = __importStar(require("react"));
var lib_1 = require("../src/lib");
var react_contexify_1 = require("react-contexify");
require("react-contexify/dist/ReactContexify.css");
var handleReadDir = function (uri) {
    return fetch("/read_dir?uri=".concat(encodeURIComponent(uri))).then(function (res) {
        return res.json();
    });
};
var MENU_ID = "context-menu";
var Tree = function () {
    var _a = (0, react_1.useState)(), root = _a[0], setRoot = _a[1];
    var currentNodeRef = (0, react_1.useRef)();
    var handlerRef = (0, react_1.useRef)(null);
    var show = (0, react_contexify_1.useContextMenu)({
        id: MENU_ID,
    }).show;
    var handleItemClick = function (_a) {
        var _b, _c, _d, _e;
        var data = _a.data;
        if (!currentNodeRef.current) {
            return;
        }
        if (data.type === "rename") {
            (_b = handlerRef.current) === null || _b === void 0 ? void 0 : _b.renameNode((_c = currentNodeRef.current) === null || _c === void 0 ? void 0 : _c.uri);
        }
        if (data.type === 'delete') {
            (_d = handlerRef.current) === null || _d === void 0 ? void 0 : _d.delete((_e = currentNodeRef.current) === null || _e === void 0 ? void 0 : _e.uri);
        }
    };
    (0, react_1.useEffect)(function () {
        fetch("/root")
            .then(function (res) { return res.json(); })
            .then(setRoot);
    }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(lib_1.FileTree, { handlerRef: handlerRef, root: root, onReadDir: handleReadDir, onContextMenu: function (e, node) {
                currentNodeRef.current = node;
                show(e);
            }, treeItemRenderer: function (treeNode) {
                var parts = treeNode.uri.split("/");
                var title = parts.pop() || "";
                if (treeNode.renaming) {
                    return (react_1.default.createElement(lib_1.RenameInput, { value: title, onBlur: function () { var _a; return (_a = handlerRef.current) === null || _a === void 0 ? void 0 : _a.cancelRename(treeNode.uri); }, onEnter: function (val) {
                            var _a;
                            (_a = handlerRef.current) === null || _a === void 0 ? void 0 : _a.renameTo(treeNode.uri, parts.concat(val).join("/"));
                        } }));
                }
                return react_1.default.createElement("div", null, title);
            } }),
        react_1.default.createElement(react_contexify_1.Menu, { id: MENU_ID },
            react_1.default.createElement(react_contexify_1.Item, { data: { type: "rename" }, onClick: handleItemClick }, "\u91CD\u547D\u540D"),
            react_1.default.createElement(react_contexify_1.Item, { data: { type: "delete" }, onClick: handleItemClick }, "\u5220\u9664"),
            react_1.default.createElement(react_contexify_1.Separator, null),
            react_1.default.createElement(react_contexify_1.Item, { disabled: true }, "Disabled"))));
};
exports.Tree = Tree;
